import es, cmdlib, playerlib
import os

dm = es.import_addon('dm')

spawn_path = dm.addondir + '/dm/addons/spawnpoints2/maps/'
spawn_locations = {'i': {'#all':[], '#t': [], '#ct': []}, 
                   'd': {'#all': [], '#t': [], '#ct': []}}

def load():
    cmdlib.registerSayCommand('!spawnpoint', cmd_add, 'Create a spawnpoint at your current location')
    
    if not os.path.isdir(spawn_path):
        os.makedirs(spawn_path)
    
    loadLocations()
    
def unload():
    cmdlib.unregisterSayCommand('!spawnpoint')
    
def cmd_add(userid, args):

    if dm.isAuthed(userid):
        if len(args) == 2:
            
            type, team = args
            if not type in ['i', 'd']:
                dm.tell(userid, 'Invalid Spawn type [i or d]')
                return
            if not team in ['#t', '#ct', '#all']:
                dm.tell(userid, 'Invalid team id [#t, #ct, #all]')
                return
            
            location = reduce(lambda x,y: '%s,%s'%(x,y), es.getplayerlocation(userid))
            angle = reduce(lambda x,y: '%s,%s'%(x,y), playerlib.getPlayer(userid).getViewAngle())
        
            spawn_locations[type][team].append([location,angle])
        
            cmap = str(es.ServerVar('eventscripts_currentmap'))
            filename = spawn_path + cmap + '.txt'
            if not os.path.isfile(filename):
                open(filename, 'w').close()
        
            x = open(filename, 'a')
            x.write('%s %s %s %s\n'%(type, team, location, angle))
            x.close()
        
            dm.tell(userid, 'Created Spawn Point (%s%s) [%s] [%s]'%(type,team,location,angle))
        else:
            dm.tell(userid, 'You did not specify a type or team')
    else:
        dm.tell(userid, 'You don\'t have access to that command!')
    
def es_map_start(ev):
    loadLocations()
    
def loadLocations():
    global spawn_locations
    cmap = str(es.ServerVar('eventscripts_currentmap'))
    spawn_locations = {'i': {'#all':[], '#t': [], '#ct': []}, 
                       'd': {'#all': [], '#t': [], '#ct': []}}
    
    if not cmap: 
        return
    
    filename = spawn_path + cmap + '.spawn'
    if os.path.isfile(filename):
        spawnfile = open(filename, 'r')
        lines = spawnfile.readlines()
        spawnfile.close()
        for line in lines:
            line = line.strip()
            if line:
                type, team, loc, ang = line.split(' ')
                spawn_locations[type][team].append(loc, ang)
                
    es.msg('loaded spawns')
    
    
def getSpawnIndexs():
    entlist = lambda x: list(es.createentitylist(x))
    return entlist('info_player_terrorist') + entlist('info_player_counterterrorist')
    
    
def killSpawns(userid=None):
    if not userid:
        userid = es.getuserid()
    
    if userid:
        for index in getSpawnIndexs():
            es.server.queuecmd('es_xremove %s'%index)
    
def round_end(ev):
    es.msg('round_end')
    es.dbgmsg(0, spawn_locations)
    userid = es.getuserid()
    if userid:
        killSpawns(userid)
            
        for details in spawn_locations['i']['#t']:
            loc, ang = details
            es.server.queuecmd(execstr%(userid, 'info_player_terrorist', loc, ang))
            
            es.dbgmsg(0, 'Initial T created')
            
        for details in spawn_locations['i']['#ct']:
            loc, ang = details
            es.server.queuecmd(execstr%(userid, 'info_player_counterterrorist', loc, ang))
            
            es.dbgmsg(0, 'Initial CT created')
            
        for details in spawn_locations['i']['#all']:
            loc, ang = details
            es.server.queuecmd(execstr%(userid, 'info_player_counterterrorist', loc, ang))
            es.server.queuecmd(execstr%(userid, 'info_player_terrorist', loc, ang))
            
            es.dbgmsg(0, 'Initial ALL created')
            
            
        es.msg('created inital spawns')
    
def dSpawns():
    userid = es.getuserid()
    killSpawns(userid)
    for details in spawn_locations['d']['#t']:
        loc, ang = details
        es.server.queuecmd(execstr%(userid, 'info_player_terrorist', loc, ang))
    for details in spawn_locations['d']['#ct']:
        loc, ang = details
        es.server.queuecmd(execstr%(userid, 'info_player_counterterrorist', loc, ang))
    for details in spawn_locations['d']['#all']:
        loc, ang = details
        es.server.queuecmd(execstr%(userid, 'info_player_counterterrorist', loc, ang))
        es.server.queuecmd(execstr%(userid, 'info_player_terrorist', loc, ang))
    
    
def round_start(ev):
    dm.delay.delayed(1, 'dm_spawnpoints2_d', dSpawns)
                
                
execstr = 'es_xgive %s %s;es_setindexprop server_var(eventscripts_lastgive) CBaseEntity.m_vecOrigin %s;es_setindexprop server_var(eventscripts_lastgive) CBaseEntity.m_angRotation %s'
            
        